// gsettings set org.gnome.desktop.background show-desktop-icons true
// gsettings set org.nemo.desktop show-desktop-icons false

const Main    = imports.ui.main;
const Lang    = imports.lang;
const Shell   = imports.gi.Shell;
const GLib    = imports.gi.GLib;
const Meta    = imports.gi.Meta;
const Gio     = imports.gi.Gio;
const Utils   = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const mySettings = Utils.getSettings();
const ShellConfig = imports.misc.config;

const key_bindings = {	'toggle-nemo': function() {_toggleNemo(0);},
				'toggle-nemo1': function() {_startApplication(1);},
				'toggle-nemo2': function() {_startApplication(2);},
				'toggle-nemo3': function() {_startApplication(3);},
				'toggle-nemo4': function() {_startApplication(4);},
				'toggle-nemo5': function() {_startApplication(5);}
			};

const WA_FOLDER = 'default-folder';
const WA_FOLDER1 = 'folder1';
const WA_FOLDER2 = 'folder2';
const WA_FOLDER3 = 'folder3';
const WA_FOLDER4 = 'folder4';
const WA_FOLDER5 = 'folder5';

var dt = new Date();

function _toggleNemo(num) {

	let win = _getWindowActor();

	// Start nautilus + block run new nautilus windows during 1s
	if (win === 'start') {
		if (new Date().getTime() > dt.getTime() ){
			dt.setTime( new Date().getTime() + 1000 );
			_startApplication(num);
			return;
		}				
	}

        if (!win) {
		dt.setTime( new Date().getTime() + 100 );
		return;
        }
        // minimize/unmaximize + 200ms between 2 minimize call
	if (win.has_focus()){
       		if (win.minimized) {
			win.unminimize();
			win.activate(global.get_current_time());
			dt.setTime( new Date().getTime() + 200 );
       		} else {
			if (new Date().getTime() > dt.getTime() ){
				dt.setTime( new Date().getTime() + 200 );
				win.minimize();
			}
         	}
	} else {
		win.unminimize();
		win.activate(global.get_current_time());
		dt.setTime( new Date().getTime() + 200 );
	}


}

function _startApplication(num){
        let folder = this.mySettings.get_string(WA_FOLDER);
        if (num >= 1) { folder = this.mySettings.get_string(WA_FOLDER1);}
        if (num >= 2) { folder = this.mySettings.get_string(WA_FOLDER2);}
        if (num >= 3) { folder = this.mySettings.get_string(WA_FOLDER3);}
        if (num >= 4) { folder = this.mySettings.get_string(WA_FOLDER4);}
        if (num >= 5) { folder = this.mySettings.get_string(WA_FOLDER5);}
	// global.log('/usr/bin/nemo ' + folder);
	global.log(folder);
	imports.misc.util.trySpawnCommandLine('/usr/bin/nemo ' + folder);
}

function _getWindowActor(){
	let window
	let ApplicationString = _("nemo.desktop");
	let searchwin =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows();
	
	//if (searchwin.length >= 2)
	//	{
			window =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows()[0];
	//	}
	//else
	//	{window =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows()[1];}

	if(typeof window == 'undefined') { window = 'start';}
	return window;
}

function init(meta) {
	Utils.initTranslations("toggle_nemo@kirby33");
}

function enable() {
    // global.log('Enable Toogle Nemo extension');
	dt.setTime(dt.getTime());
	let key;	
	for(key in key_bindings) 
	{
 		if (Main.wm.addKeybinding && Shell.KeyBindingMode) 
		{ 
            // global.log('Toogle Nemo extension: 1 - Add  KeyBinding '+key);
			Main.wm.addKeybinding(key,mySettings,Meta.KeyBindingFlags.NONE, Shell.KeyBindingMode.NORMAL | Shell.KeyBindingMode.MESSAGE_TRAY,key_bindings[key]); 
		}
		else if (Main.wm.addKeybinding && Main.KeybindingMode) 
			{
				// global.log('Toogle Nemo extension: 2 - Add  KeyBinding '+key);
				Main.wm.addKeybinding(key,mySettings,Meta.KeyBindingFlags.NONE,Main.KeybindingMode.NORMAL | Main.KeybindingMode.MESSAGE_TRAY, key_bindings[key]);
			} 
			else 
			{
				// global.log('Toogle Nemo extension: 3 - Add  KeyBinding '+key+' '+key_bindings[key]);
				global.display.add_keybinding(key,mySettings,Meta.KeyBindingFlags.NONE,key_bindings[key]); 
				Main.wm.setCustomKeybindingHandler(key, Shell.ActionMode.NORMAL | Shell.ActionMode.OVERVIEW, key_bindings[key] );

			}
	}
}

function disable() {
    // global.log('Disable Toogle Nemo extension');
	let key;
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
