const GObject = imports.gi.GObject;
const Gdk = imports.gi.Gdk;
const Gtk = imports.gi.Gtk;
const Lang = imports.lang;
const Utils = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const mySettings = Utils.getSettings();
const WA_FOLDER  = 'default-folder';
const WA_FOLDER1 = 'folder1';
const WA_FOLDER2 = 'folder2';
const WA_FOLDER3 = 'folder3';
const WA_FOLDER4 = 'folder4';
const WA_FOLDER5 = 'folder5';


// End of imports;

const pretty_names = {
	'toggle-nemo': 'Toggle nemo',
	'toggle-nemo1': 'Toggle nemo folder 1',
	'toggle-nemo2': 'Toggle nemo folder 2',
	'toggle-nemo3': 'Toggle nemo folder 3',
	'toggle-nemo4': 'Toggle nemo folder 4',
	'toggle-nemo5': 'Toggle nemo folder 5'
}

function init() {
}

function append_hotkey(model, settings, name, pretty_name) {
	let [key, mods] = Gtk.accelerator_parse(settings.get_strv(name)[0]);

	let row = model.insert(10);

	model.set(row, [0, 1, 2, 3], [name, pretty_name, 
		mods, key ]);
}

function changefolder(object, text) {this.mySettings.set_string(WA_FOLDER, text.get_text());}
function changefolder_f1(object, text) {this.mySettings.set_string(WA_FOLDER1, text.get_text());}
function changefolder_f2(object, text) {this.mySettings.set_string(WA_FOLDER2, text.get_text());}
function changefolder_f3(object, text) {this.mySettings.set_string(WA_FOLDER3, text.get_text());}
function changefolder_f4(object, text) {this.mySettings.set_string(WA_FOLDER4, text.get_text());}
function changefolder_f5(object, text) {this.mySettings.set_string(WA_FOLDER5, text.get_text());}

function buildPrefsWidget() {
	let frame = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, border_width: 1 });
	let vbox1 = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, margin_left: 1 });
	let label = new Gtk.Label({ label: "<b>Global</b>", use_markup: true, xalign: 0 });

	let hboxMenu1 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu1 = new Gtk.Label({label: "Default folder", xalign: 0});
	let valueMenu1 = new Gtk.Entry({ hexpand: true });
	valueMenu1.set_text(this.mySettings.get_string(WA_FOLDER));
	let buttonMenu = new Gtk.Button({ label: "Apply" });
	buttonMenu.connect("clicked", Lang.bind(this, this.changefolder  , valueMenu1 ));
	hboxMenu1.pack_start(labelMenu1, true, true, 0);
	hboxMenu1.add(valueMenu1);
	hboxMenu1.add(buttonMenu);

	// GUI folder 1
	let hboxMenu_f1 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu_f1 = new Gtk.Label({label: "folder 1", xalign: 0});
	let valueMenu_f1 = new Gtk.Entry({ hexpand: true });
	valueMenu_f1.set_text(this.mySettings.get_string(WA_FOLDER1));
	let buttonMenu_f1 = new Gtk.Button({ label: "Apply" });
	buttonMenu_f1.connect("clicked", Lang.bind(this, this.changefolder_f1  , valueMenu_f1 ));
	hboxMenu_f1.pack_start(labelMenu_f1, true, true, 0);
	hboxMenu_f1.add(valueMenu_f1);
	hboxMenu_f1.add(buttonMenu_f1);

	// GUI folder 2
	let hboxMenu_f2 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu_f2 = new Gtk.Label({label: "folder 2", xalign: 0});
	let valueMenu_f2 = new Gtk.Entry({ hexpand: true });
	valueMenu_f2.set_text(this.mySettings.get_string(WA_FOLDER2));
	let buttonMenu_f2 = new Gtk.Button({ label: "Apply" });
	buttonMenu_f2.connect("clicked", Lang.bind(this, this.changefolder_f2  , valueMenu_f2 ));
	hboxMenu_f2.pack_start(labelMenu_f2, true, true, 0);
	hboxMenu_f2.add(valueMenu_f2);
	hboxMenu_f2.add(buttonMenu_f2);

	// GUI folder 3
	let hboxMenu_f3 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu_f3 = new Gtk.Label({label: "folder 3", xalign: 0});
	let valueMenu_f3 = new Gtk.Entry({ hexpand: true });
	valueMenu_f3.set_text(this.mySettings.get_string(WA_FOLDER3));
	let buttonMenu_f3 = new Gtk.Button({ label: "Apply" });
	buttonMenu_f3.connect("clicked", Lang.bind(this, this.changefolder_f3  , valueMenu_f3 ));
	hboxMenu_f3.pack_start(labelMenu_f3, true, true, 0);
	hboxMenu_f3.add(valueMenu_f3);
	hboxMenu_f3.add(buttonMenu_f3);

	// GUI folder 4
	let hboxMenu_f4 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu_f4 = new Gtk.Label({label: "folder 4", xalign: 0});
	let valueMenu_f4 = new Gtk.Entry({ hexpand: true });
	valueMenu_f4.set_text(this.mySettings.get_string(WA_FOLDER4));
	let buttonMenu_f4 = new Gtk.Button({ label: "Apply" });
	buttonMenu_f4.connect("clicked", Lang.bind(this, this.changefolder_f4  , valueMenu_f4 ));
	hboxMenu_f4.pack_start(labelMenu_f4, true, true, 0);
	hboxMenu_f4.add(valueMenu_f4);
	hboxMenu_f4.add(buttonMenu_f4);

	// GUI folder 5
	let hboxMenu_f5 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu_f5 = new Gtk.Label({label: "folder 5", xalign: 0});
	let valueMenu_f5 = new Gtk.Entry({ hexpand: true });
	valueMenu_f5.set_text(this.mySettings.get_string(WA_FOLDER5));
	let buttonMenu_f5 = new Gtk.Button({ label: "Apply" });
	buttonMenu_f5.connect("clicked", Lang.bind(this, this.changefolder_f5  , valueMenu_f5 ));
	hboxMenu_f5.pack_start(labelMenu_f5, true, true, 0);
	hboxMenu_f5.add(valueMenu_f5);
	hboxMenu_f5.add(buttonMenu_f5);

	vbox1.add(hboxMenu1);

	vbox1.add(hboxMenu_f1);
	vbox1.add(hboxMenu_f2);
	vbox1.add(hboxMenu_f3);
	vbox1.add(hboxMenu_f4);
	vbox1.add(hboxMenu_f5);

	frame.add(label);
	frame.add(vbox1);

	let model = new Gtk.ListStore();

	model.set_column_types([
		GObject.TYPE_STRING,
		GObject.TYPE_STRING,
		GObject.TYPE_INT,
		GObject.TYPE_INT
	]);

	global.log("Modal created.");

	let settings = Utils.getSettings();

	for(key in pretty_names) {
		append_hotkey(model, settings, key, pretty_names[key]);
	}

	global.log("Added hotkeys to model");

	let treeview = new Gtk.TreeView({
		'expand': true,
		'model': model
	});

	global.log("TreeView created.");

	let col;
	let cellrend;

	cellrend = new Gtk.CellRendererText();

	col = new Gtk.TreeViewColumn({
		'title': 'Keybinding',
		'expand': true
	});

	col.pack_start(cellrend, true);
	col.add_attribute(cellrend, 'text', 1);


	treeview.append_column(col);

	global.log("Column one created.");

	cellrend = new Gtk.CellRendererAccel({
		'editable': true,
		'accel-mode': Gtk.CellRendererAccelMode.GTK
	});

	cellrend.connect('accel-edited', function(rend, iter, key, mods) {
		let value = Gtk.accelerator_name(key, mods);
		
		let [succ, iter ] = model.get_iter_from_string(iter);
		
		if(!succ) {
			throw new Error("Something be broken, yo.");
		}

		let name = model.get_value(iter, 0);

		model.set(iter, [ 2, 3 ], [ mods, key ]);

		global.log("Changing value for " + name + ": " + value);

		settings.set_strv(name, [value]);
	});

	col = new Gtk.TreeViewColumn({
		'title': 'Accel'
	});

	col.pack_end(cellrend, false);
	col.add_attribute(cellrend, 'accel-mods', 2);
	col.add_attribute(cellrend, 'accel-key', 3);

	treeview.append_column(col);
	
	global.log("Column two created.");

	let win = new Gtk.ScrolledWindow({
		'vexpand': true
	});
	win.add(treeview);

	global.log("ScrolledWindow created.");
	


	global.log("Returning.");


	let hboxMenu2 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	hboxMenu2.add(win);
	vbox1.add(hboxMenu2);


	frame.show_all();
	return frame;
}



